"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _CreditBalance = _interopRequireDefault(require("../model/CreditBalance"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
/**
* MetaAPI service.
* @module api/MetaAPIApi
* @version 1.0.0
*/
var MetaAPIApi = /*#__PURE__*/function () {
  /**
  * Constructs a new MetaAPIApi. 
  * @alias module:api/MetaAPIApi
  * @class
  * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
  * default to {@link module:ApiClient#instance} if unspecified.
  */
  function MetaAPIApi(apiClient) {
    _classCallCheck(this, MetaAPIApi);
    this.apiClient = apiClient || _ApiClient["default"].instance;
  }

  /**
   * Callback function to receive the result of the viewCreditBalanceEndpoint operation.
   * @callback module:api/MetaAPIApi~viewCreditBalanceEndpointCallback
   * @param {String} error Error message, if any.
   * @param {module:model/CreditBalance} data The data returned by the service call.
   * @param {String} response The complete HTTP response.
   */

  /**
   * Cost: 0 credit / successful request. Get your current credit(s) balance
   * @param {module:api/MetaAPIApi~viewCreditBalanceEndpointCallback} callback The callback function, accepting three arguments: error, data, response
   * data is of type: {@link module:model/CreditBalance}
   */
  _createClass(MetaAPIApi, [{
    key: "viewCreditBalanceEndpoint",
    value: function viewCreditBalanceEndpoint(callback) {
      var postBody = null;
      var pathParams = {};
      var queryParams = {};
      var headerParams = {};
      var formParams = {};
      var authNames = ['BearerAuth'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _CreditBalance["default"];
      return this.apiClient.callApi('/api/credit-balance', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }
  }]);
  return MetaAPIApi;
}();
exports["default"] = MetaAPIApi;