"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _CompanyReveal = _interopRequireDefault(require("../model/CompanyReveal"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
/**
* RevealAPI service.
* @module api/RevealAPIApi
* @version 1.0.0
*/
var RevealAPIApi = /*#__PURE__*/function () {
  /**
  * Constructs a new RevealAPIApi. 
  * @alias module:api/RevealAPIApi
  * @class
  * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
  * default to {@link module:ApiClient#instance} if unspecified.
  */
  function RevealAPIApi(apiClient) {
    _classCallCheck(this, RevealAPIApi);
    this.apiClient = apiClient || _ApiClient["default"].instance;
  }

  /**
   * Callback function to receive the result of the revealEndpoint operation.
   * @callback module:api/RevealAPIApi~revealEndpointCallback
   * @param {String} error Error message, if any.
   * @param {module:model/CompanyReveal} data The data returned by the service call.
   * @param {String} response The complete HTTP response.
   */

  /**
   * Cost: 2 credits / successful request. Deanonymize an IPv4 address and associate the Company behind the IPv4 address.
   * @param {String} ip      The target IPv4 address.     
   * @param {Object} opts Optional parameters
   * @param {String} opts.roleContactNumber      Append personal contact numbers to the response if the system finds a relevant person profile.     
   * @param {String} opts.rolePersonalEmail      Append personal email addresses to the response if the system finds a relevant person profile.     
   * @param {String} opts.role      Lookup and append an employee of a certain role of the company.     Within the same API call, You can choose to lookup a person with a given role within this organisation that you might want to reach out to.     
   * @param {module:api/RevealAPIApi~revealEndpointCallback} callback The callback function, accepting three arguments: error, data, response
   * data is of type: {@link module:model/CompanyReveal}
   */
  _createClass(RevealAPIApi, [{
    key: "revealEndpoint",
    value: function revealEndpoint(ip, opts, callback) {
      opts = opts || {};
      var postBody = null;
      // verify the required parameter 'ip' is set
      if (ip === undefined || ip === null) {
        throw new Error("Missing the required parameter 'ip' when calling revealEndpoint");
      }
      var pathParams = {};
      var queryParams = {
        'role_contact_number': opts['roleContactNumber'],
        'role_personal_email': opts['rolePersonalEmail'],
        'role': opts['role'],
        'ip': ip
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['BearerAuth'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _CompanyReveal["default"];
      return this.apiClient.callApi('/api/reveal/company', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }
  }]);
  return RevealAPIApi;
}();
exports["default"] = RevealAPIApi;