"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _CompanyUpdatePostedOn = _interopRequireDefault(require("./CompanyUpdatePostedOn"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
/**
 * The Education model module.
 * @module model/Education
 * @version 1.0.0
 */
var Education = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>Education</code>.
   * @alias module:model/Education
   */
  function Education() {
    _classCallCheck(this, Education);
    Education.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(Education, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>Education</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Education} obj Optional instance to populate.
     * @return {module:model/Education} The populated <code>Education</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new Education();
        if (data.hasOwnProperty('starts_at')) {
          obj['starts_at'] = _CompanyUpdatePostedOn["default"].constructFromObject(data['starts_at']);
        }
        if (data.hasOwnProperty('ends_at')) {
          obj['ends_at'] = _CompanyUpdatePostedOn["default"].constructFromObject(data['ends_at']);
        }
        if (data.hasOwnProperty('field_of_study')) {
          obj['field_of_study'] = _ApiClient["default"].convertToType(data['field_of_study'], 'String');
        }
        if (data.hasOwnProperty('degree_name')) {
          obj['degree_name'] = _ApiClient["default"].convertToType(data['degree_name'], 'String');
        }
        if (data.hasOwnProperty('school')) {
          obj['school'] = _ApiClient["default"].convertToType(data['school'], 'String');
        }
        if (data.hasOwnProperty('school_linkedin_profile_url')) {
          obj['school_linkedin_profile_url'] = _ApiClient["default"].convertToType(data['school_linkedin_profile_url'], 'String');
        }
        if (data.hasOwnProperty('description')) {
          obj['description'] = _ApiClient["default"].convertToType(data['description'], 'String');
        }
        if (data.hasOwnProperty('logo_url')) {
          obj['logo_url'] = _ApiClient["default"].convertToType(data['logo_url'], 'String');
        }
      }
      return obj;
    }

    /**
     * Validates the JSON data with respect to <code>Education</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>Education</code>.
     */
  }, {
    key: "validateJSON",
    value: function validateJSON(data) {
      // validate the optional field `starts_at`
      if (data['starts_at']) {
        // data not null
        _CompanyUpdatePostedOn["default"].validateJSON(data['starts_at']);
      }
      // validate the optional field `ends_at`
      if (data['ends_at']) {
        // data not null
        _CompanyUpdatePostedOn["default"].validateJSON(data['ends_at']);
      }
      // ensure the json data is a string
      if (data['field_of_study'] && !(typeof data['field_of_study'] === 'string' || data['field_of_study'] instanceof String)) {
        throw new Error("Expected the field `field_of_study` to be a primitive type in the JSON string but got " + data['field_of_study']);
      }
      // ensure the json data is a string
      if (data['degree_name'] && !(typeof data['degree_name'] === 'string' || data['degree_name'] instanceof String)) {
        throw new Error("Expected the field `degree_name` to be a primitive type in the JSON string but got " + data['degree_name']);
      }
      // ensure the json data is a string
      if (data['school'] && !(typeof data['school'] === 'string' || data['school'] instanceof String)) {
        throw new Error("Expected the field `school` to be a primitive type in the JSON string but got " + data['school']);
      }
      // ensure the json data is a string
      if (data['school_linkedin_profile_url'] && !(typeof data['school_linkedin_profile_url'] === 'string' || data['school_linkedin_profile_url'] instanceof String)) {
        throw new Error("Expected the field `school_linkedin_profile_url` to be a primitive type in the JSON string but got " + data['school_linkedin_profile_url']);
      }
      // ensure the json data is a string
      if (data['description'] && !(typeof data['description'] === 'string' || data['description'] instanceof String)) {
        throw new Error("Expected the field `description` to be a primitive type in the JSON string but got " + data['description']);
      }
      // ensure the json data is a string
      if (data['logo_url'] && !(typeof data['logo_url'] === 'string' || data['logo_url'] instanceof String)) {
        throw new Error("Expected the field `logo_url` to be a primitive type in the JSON string but got " + data['logo_url']);
      }
      return true;
    }
  }]);
  return Education;
}();
/**
 * @member {module:model/CompanyUpdatePostedOn} starts_at
 */
Education.prototype['starts_at'] = undefined;

/**
 * @member {module:model/CompanyUpdatePostedOn} ends_at
 */
Education.prototype['ends_at'] = undefined;

/**
 * @member {String} field_of_study
 */
Education.prototype['field_of_study'] = undefined;

/**
 * @member {String} degree_name
 */
Education.prototype['degree_name'] = undefined;

/**
 * @member {String} school
 */
Education.prototype['school'] = undefined;

/**
 * @member {String} school_linkedin_profile_url
 */
Education.prototype['school_linkedin_profile_url'] = undefined;

/**
 * @member {String} description
 */
Education.prototype['description'] = undefined;

/**
 * @member {String} logo_url
 */
Education.prototype['logo_url'] = undefined;
var _default = Education;
exports["default"] = _default;