"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _PersonExtra = _interopRequireDefault(require("./PersonExtra"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
/**
 * The PersonEndpointResponseExtra model module.
 * @module model/PersonEndpointResponseExtra
 * @version 1.0.0
 */
var PersonEndpointResponseExtra = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>PersonEndpointResponseExtra</code>.
   * A bundle of extra data on this user.
   * @alias module:model/PersonEndpointResponseExtra
   * @implements module:model/PersonExtra
   */
  function PersonEndpointResponseExtra() {
    _classCallCheck(this, PersonEndpointResponseExtra);
    _PersonExtra["default"].initialize(this);
    PersonEndpointResponseExtra.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(PersonEndpointResponseExtra, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>PersonEndpointResponseExtra</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/PersonEndpointResponseExtra} obj Optional instance to populate.
     * @return {module:model/PersonEndpointResponseExtra} The populated <code>PersonEndpointResponseExtra</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new PersonEndpointResponseExtra();
        _PersonExtra["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('github_profile_id')) {
          obj['github_profile_id'] = _ApiClient["default"].convertToType(data['github_profile_id'], 'String');
        }
        if (data.hasOwnProperty('facebook_profile_id')) {
          obj['facebook_profile_id'] = _ApiClient["default"].convertToType(data['facebook_profile_id'], 'String');
        }
        if (data.hasOwnProperty('twitter_profile_id')) {
          obj['twitter_profile_id'] = _ApiClient["default"].convertToType(data['twitter_profile_id'], 'String');
        }
      }
      return obj;
    }

    /**
     * Validates the JSON data with respect to <code>PersonEndpointResponseExtra</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>PersonEndpointResponseExtra</code>.
     */
  }, {
    key: "validateJSON",
    value: function validateJSON(data) {
      // ensure the json data is a string
      if (data['github_profile_id'] && !(typeof data['github_profile_id'] === 'string' || data['github_profile_id'] instanceof String)) {
        throw new Error("Expected the field `github_profile_id` to be a primitive type in the JSON string but got " + data['github_profile_id']);
      }
      // ensure the json data is a string
      if (data['facebook_profile_id'] && !(typeof data['facebook_profile_id'] === 'string' || data['facebook_profile_id'] instanceof String)) {
        throw new Error("Expected the field `facebook_profile_id` to be a primitive type in the JSON string but got " + data['facebook_profile_id']);
      }
      // ensure the json data is a string
      if (data['twitter_profile_id'] && !(typeof data['twitter_profile_id'] === 'string' || data['twitter_profile_id'] instanceof String)) {
        throw new Error("Expected the field `twitter_profile_id` to be a primitive type in the JSON string but got " + data['twitter_profile_id']);
      }
      return true;
    }
  }]);
  return PersonEndpointResponseExtra;
}();
/**
 * This profile's Github account.
 * @member {String} github_profile_id
 */
PersonEndpointResponseExtra.prototype['github_profile_id'] = undefined;

/**
 * This profile's Facebook account.
 * @member {String} facebook_profile_id
 */
PersonEndpointResponseExtra.prototype['facebook_profile_id'] = undefined;

/**
 * This profile's twitter account.
 * @member {String} twitter_profile_id
 */
PersonEndpointResponseExtra.prototype['twitter_profile_id'] = undefined;

// Implement PersonExtra interface:
/**
 * This profile's Github account.
 * @member {String} github_profile_id
 */
_PersonExtra["default"].prototype['github_profile_id'] = undefined;
/**
 * This profile's Facebook account.
 * @member {String} facebook_profile_id
 */
_PersonExtra["default"].prototype['facebook_profile_id'] = undefined;
/**
 * This profile's twitter account.
 * @member {String} twitter_profile_id
 */
_PersonExtra["default"].prototype['twitter_profile_id'] = undefined;
var _default = PersonEndpointResponseExtra;
exports["default"] = _default;