"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _InferredSalary = _interopRequireDefault(require("./InferredSalary"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
/**
 * The PersonEndpointResponseInferredSalary model module.
 * @module model/PersonEndpointResponseInferredSalary
 * @version 1.0.0
 */
var PersonEndpointResponseInferredSalary = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>PersonEndpointResponseInferredSalary</code>.
   * A salary range inferred from the user&#39;s current job title and company.
   * @alias module:model/PersonEndpointResponseInferredSalary
   * @implements module:model/InferredSalary
   */
  function PersonEndpointResponseInferredSalary() {
    _classCallCheck(this, PersonEndpointResponseInferredSalary);
    _InferredSalary["default"].initialize(this);
    PersonEndpointResponseInferredSalary.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(PersonEndpointResponseInferredSalary, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>PersonEndpointResponseInferredSalary</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/PersonEndpointResponseInferredSalary} obj Optional instance to populate.
     * @return {module:model/PersonEndpointResponseInferredSalary} The populated <code>PersonEndpointResponseInferredSalary</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new PersonEndpointResponseInferredSalary();
        _InferredSalary["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('min')) {
          obj['min'] = _ApiClient["default"].convertToType(data['min'], 'Number');
        }
        if (data.hasOwnProperty('max')) {
          obj['max'] = _ApiClient["default"].convertToType(data['max'], 'Number');
        }
      }
      return obj;
    }

    /**
     * Validates the JSON data with respect to <code>PersonEndpointResponseInferredSalary</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>PersonEndpointResponseInferredSalary</code>.
     */
  }, {
    key: "validateJSON",
    value: function validateJSON(data) {
      return true;
    }
  }]);
  return PersonEndpointResponseInferredSalary;
}();
/**
 * @member {Number} min
 */
PersonEndpointResponseInferredSalary.prototype['min'] = undefined;

/**
 * @member {Number} max
 */
PersonEndpointResponseInferredSalary.prototype['max'] = undefined;

// Implement InferredSalary interface:
/**
 * @member {Number} min
 */
_InferredSalary["default"].prototype['min'] = undefined;
/**
 * @member {Number} max
 */
_InferredSalary["default"].prototype['max'] = undefined;
var _default = PersonEndpointResponseInferredSalary;
exports["default"] = _default;