"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
/**
 * The ProfilePicture model module.
 * @module model/ProfilePicture
 * @version 1.0.0
 */
var ProfilePicture = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ProfilePicture</code>.
   * @alias module:model/ProfilePicture
   */
  function ProfilePicture() {
    _classCallCheck(this, ProfilePicture);
    ProfilePicture.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(ProfilePicture, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>ProfilePicture</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ProfilePicture} obj Optional instance to populate.
     * @return {module:model/ProfilePicture} The populated <code>ProfilePicture</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ProfilePicture();
        if (data.hasOwnProperty('tmp_profile_pic_url')) {
          obj['tmp_profile_pic_url'] = _ApiClient["default"].convertToType(data['tmp_profile_pic_url'], 'String');
        }
      }
      return obj;
    }

    /**
     * Validates the JSON data with respect to <code>ProfilePicture</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>ProfilePicture</code>.
     */
  }, {
    key: "validateJSON",
    value: function validateJSON(data) {
      // ensure the json data is a string
      if (data['tmp_profile_pic_url'] && !(typeof data['tmp_profile_pic_url'] === 'string' || data['tmp_profile_pic_url'] instanceof String)) {
        throw new Error("Expected the field `tmp_profile_pic_url` to be a primitive type in the JSON string but got " + data['tmp_profile_pic_url']);
      }
      return true;
    }
  }]);
  return ProfilePicture;
}();
/**
 *              Temporary URL to the profile picture (valid for just 30 minutes).             See this [blog post](https://nubela.co/blog/why-is-the-api-returning-s3-links-for-profile-pictures-scraped-from-linkedin-profiles/) for more information.
 * @member {String} tmp_profile_pic_url
 */
ProfilePicture.prototype['tmp_profile_pic_url'] = undefined;
var _default = ProfilePicture;
exports["default"] = _default;