"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
/**
 * The RoleSearchResult model module.
 * @module model/RoleSearchResult
 * @version 1.0.0
 */
var RoleSearchResult = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>RoleSearchResult</code>.
   * @alias module:model/RoleSearchResult
   */
  function RoleSearchResult() {
    _classCallCheck(this, RoleSearchResult);
    RoleSearchResult.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(RoleSearchResult, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>RoleSearchResult</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/RoleSearchResult} obj Optional instance to populate.
     * @return {module:model/RoleSearchResult} The populated <code>RoleSearchResult</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new RoleSearchResult();
        if (data.hasOwnProperty('linkedin_profile_url')) {
          obj['linkedin_profile_url'] = _ApiClient["default"].convertToType(data['linkedin_profile_url'], 'String');
        }
      }
      return obj;
    }

    /**
     * Validates the JSON data with respect to <code>RoleSearchResult</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>RoleSearchResult</code>.
     */
  }, {
    key: "validateJSON",
    value: function validateJSON(data) {
      // ensure the json data is a string
      if (data['linkedin_profile_url'] && !(typeof data['linkedin_profile_url'] === 'string' || data['linkedin_profile_url'] instanceof String)) {
        throw new Error("Expected the field `linkedin_profile_url` to be a primitive type in the JSON string but got " + data['linkedin_profile_url']);
      }
      return true;
    }
  }]);
  return RoleSearchResult;
}();
/**
 * LinkedIn Profile URL of the person that most closely matches the role
 * @member {String} linkedin_profile_url
 */
RoleSearchResult.prototype['linkedin_profile_url'] = undefined;
var _default = RoleSearchResult;
exports["default"] = _default;